#define setadlib adlib

#include "iku_musa.h"
#include "dos.h"

char cord=0,cpat=0,crow=0,drmt=0xff,drms=0;
int arpg=0,arpg2=0,arpg3=0;

char audioks;
int plrbeep[3];

/***************** h00KiNG nEW iNTERRuPT hANDLeRs **************/

void interrupt int_8();
void interrupt (*old_int8)();

unsigned int taimeri;

kellovauhti(char spiidi)
{
      disable();
      outportb(0x43,0x36);
      outportb(0x40,0x00);
      outportb(0x40,spiidi);
      enable();
}

timer_on()
{   taimeri=0;

    if(audioks){/*luestm();*/
                initsound();
                cpat=patord[0];}

    disable();
    old_int8=getvect(0x08);
    setvect(0x08,int_8);
    enable();
    kellovauhti(64);
}

timer_off()
{
      disable();
      setvect(0x08,old_int8);
      enable();
      kellovauhti(0);

      if(audioks)initsound();
}

void interrupt int_8()
{
      taimeri++;

      if (!(taimeri&3)) (*old_int8)(); else outport(0x20,0x20);

      if(audioks)playtick();
}

/**********************************************************/
/******************* pLAYVVERr RUTiNE ********************/

char instru[2][11]={
    0xa0,0xa1,0xff,0xff,0x0f,0x0f,0x00,0x00,0x00,0x00,0x00,  /* bass? */
    0xa2,0xa2,0xff,0xff,0x0f,0x0f,0x03,0x03,0x01,0x00,0x00,  /* ohrgan */
};

/* modulaatiot 8 ja 2/4, wavet 0 ja 1/2, fm
   modulaatiot 2 ja 2, wavet 3 ja 3, nou fm */

ldinstr(char kanava,char *ins)
{
    char osotte[11] = {
    0x20,0x23,0x60,0x63,0x80,0x83,0xe0,0xe3,0xc0,0x40,0x43 };

      char *tmp=ins; char l;
      for(l=0;l<11;l++) adlib(kanava+osotte[l],*tmp++);
}

initsound()
{
      int l;
      if(audioks==2){
      for(l=0;l<244;l++) setadlib(l,0);
      adlib(0x01,0x20);
      ldinstr(0,instru[1]);
      ldinstr(1,instru[0]);
      ldinstr(2,instru[1]);}else nosound();
}

int freku[12] = {
		0x157,0x16b,0x181,0x198,0x1b0,0x1ca,
		 0x1e5,0x202,0x220,0x241,0x263,0x287
		 };

/*char trax[12][4][64];*/

/*
kirjstm()
{
      FILE *stm;
      char l,l2,l3;
      stm=fopen("iku_musa.h","w");
      fprintf(stm,"char patord[]={");
      for(l=0;l<32;l++) fprintf(stm,"%i,",patord[l]);
      fprintf(stm,"\n\rchar trax[12][3][64]={\n\r");
      for(l=0;l<12;l++){fprintf(stm,"\n\r*PATTERN %i*\n\r",l);
      for(l2=0;l2<3;l2++){fprintf(stm,"\n\r");
      for(l3=0;l3<64;l3++) fprintf(stm,"%i,",trax[l][l2][l3]);
      }}
}
*/

/*
luestm()
{
      FILE *stm;
      int l,l2,l3;
      char maxp;
      char okt,nuot,snum,vlo,vhi,efkod,vlu,efbyte;
      char kodh;

      stm=fopen("tu3.stm","rb");

      maxp=0;
      for(l=0x410;l;l--) fgetc(stm);
      cprintf("\n\rOhitettu 0x410 asti");
      cprintf("\n\rOrderi: ");
      for(l=0;l<128;l++) {
            patord[l]=fgetc(stm);
            if (patord[l]<99) if (patord[l]>maxp) maxp=patord[l];
            cprintf("%i - ",patord[l]);
      }

      maxp++; cprintf("\n\rPatternien mr: %i",maxp);
      cprintf("\n\rLuetaan patternit: ");

      for(l=0;l<maxp;l++) { cprintf("%i..",l);

      for(l2=0;l2<64;l2++)
      for(l3=0;l3<4;l3++)
      {
            vlu=fgetc(stm);   okt=(vlu>>4);
                              nuot=vlu&15;       * nuot: f=sama *
            vlu=fgetc(stm);   snum=vlu>>3;       * numerot 1..x, 0=sama *
                              vlo=vlu&7;         * volumet 0..64, "sama"=? *
            vlu=fgetc(stm);   vhi=vlu>>4;
			      efkod=(vlu&15)<<4;
	    efbyte=fgetc(stm);

            vlu=(vlo+(8*vhi));

            kodh=0;
            if (vlu<2)  kodh=0xfe; else     * volumeoff *
            if (nuot==0xf) kodh=0xff;       * nochange *

	    if (!kodh) kodh=(okt*16)|nuot;

            trax[l][l3][l2]=kodh;

      }}

      cprintf("\n\rPatternit luettu!");
      fclose(stm);

      cprintf("\n\rWRiTING sYSTEMZ dOWN");
      kirjstm();
}
*/

char plst=0;

playtick()
{
      plst++;
      if(audioks==1){
            if(plst==1){
                  if (plrbeep[1]) sound(plrbeep[1]>>1);
                             else nosound();}
            if(plst==3){
                  if (plrbeep[2]) sound(plrbeep[2]);
                             else nosound();}
            }
      if (plst==4) { uusinuotti(); plst=0; }
}

uusinuotti()
{
      int l;
      char mark,temp;int hum;

      for(l=0;l<3;l++) {

            mark=trax[cpat][l][crow];

	    if (mark==0xfe) {if(audioks==2) {adlib(0x40+l,63);
					if(l!=1)adlib(0x43+l,60);}
                                       else plrbeep[l]=0;}

            if (mark<0xf0) {

	      hum=(freku[mark&15])
		  |(32*256)|
		  ((mark&(255-15))*64);

             if (audioks==2){
              adlib(0xb0+l,hum>>8);
              adlib(0xa0+l,hum&255);
	      adlib(0x40+l,2);
	      if(l!=1)adlib(0x43+l,2);}

		plrbeep[l]=freku[mark&15];
		plrbeep[l]<<=((( (mark-64) >>4)&15)-2);
	      }

      }

     crow++;   if (crow==64) {
                crow=0;cord++;
                cpat=patord[cord];
                if (cpat==99) { cord=0; cpat=patord[cord]; }}
}



